<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="" xml:lang="">
<head>
  <meta charset="utf-8" />
  <meta name="generator" content="pandoc" />
  <meta name="viewport" content="width=device-width, initial-scale=1.0, user-scalable=yes" />

  <link rel="stylesheet" href="https://use.fontawesome.com/releases/v5.7.0/css/all.css" integrity="sha384-lZN37f5QGtY3VHgisS14W3ExzMWZxybE1SJSEsQp9S+oqd12jhcu+A56Ebc1zFSJ" crossorigin="anonymous">

  <title>Creating Georectified Maps of Refugee and Asylum Flows</title>
  <style>
      code{white-space: pre-wrap;}
      span.smallcaps{font-variant: small-caps;}
      span.underline{text-decoration: underline;}
      div.column{display: inline-block; vertical-align: top; width: 50%;}
  </style>

  <style>
a.sourceLine { display: inline-block; line-height: 1.25; }
a.sourceLine { pointer-events: none; color: inherit; text-decoration: inherit; }
a.sourceLine:empty { height: 1.2em; }
.sourceCode { overflow: visible; }
code.sourceCode { white-space: pre; position: relative; }
div.sourceCode { margin: 1em 0; }
pre.sourceCode { margin: 0; }
@media screen {
div.sourceCode { overflow: auto; }
}
@media print {
code.sourceCode { white-space: pre-wrap; }
a.sourceLine { text-indent: -1em; padding-left: 1em; }
}
pre.numberSource a.sourceLine
  { position: relative; left: -4em; }
pre.numberSource a.sourceLine::before
  { content: attr(data-line-number);
    position: relative; left: -1em; text-align: right; vertical-align: baseline;
    border: none; pointer-events: all; display: inline-block;
    -webkit-touch-callout: none; -webkit-user-select: none;
    -khtml-user-select: none; -moz-user-select: none;
    -ms-user-select: none; user-select: none;
    padding: 0 4px; width: 4em;
    color: #aaaaaa;
  }
pre.numberSource { margin-left: 3em; border-left: 1px solid #aaaaaa;  padding-left: 4px; }
div.sourceCode
  {  }
@media screen {
a.sourceLine::before { text-decoration: underline; }
}
code span.al { color: #ff0000; font-weight: bold; } /* Alert */
code span.an { color: #60a0b0; font-weight: bold; font-style: italic; } /* Annotation */
code span.at { color: #7d9029; } /* Attribute */
code span.bn { color: #40a070; } /* BaseN */
code span.bu { } /* BuiltIn */
code span.cf { color: #007020; font-weight: bold; } /* ControlFlow */
code span.ch { color: #4070a0; } /* Char */
code span.cn { color: #880000; } /* Constant */
code span.co { color: #60a0b0; font-style: italic; } /* Comment */
code span.cv { color: #60a0b0; font-weight: bold; font-style: italic; } /* CommentVar */
code span.do { color: #ba2121; font-style: italic; } /* Documentation */
code span.dt { color: #902000; } /* DataType */
code span.dv { color: #40a070; } /* DecVal */
code span.er { color: #ff0000; font-weight: bold; } /* Error */
code span.ex { } /* Extension */
code span.fl { color: #40a070; } /* Float */
code span.fu { color: #06287e; } /* Function */
code span.im { } /* Import */
code span.in { color: #60a0b0; font-weight: bold; font-style: italic; } /* Information */
code span.kw { color: #007020; font-weight: bold; } /* Keyword */
code span.op { color: #666666; } /* Operator */
code span.ot { color: #007020; } /* Other */
code span.pp { color: #bc7a00; } /* Preprocessor */
code span.sc { color: #4070a0; } /* SpecialChar */
code span.ss { color: #bb6688; } /* SpecialString */
code span.st { color: #4070a0; } /* String */
code span.va { color: #19177c; } /* Variable */
code span.vs { color: #4070a0; } /* VerbatimString */
code span.wa { color: #60a0b0; font-weight: bold; font-style: italic; } /* Warning */
  </style>

  <link rel="stylesheet" href="/usr/local/lib/R/site-library/danteSubmit/rmarkdown/templates/dante_vignette/resources/style.css" />

  <!--[if lt IE 9]>
    <script src="//cdnjs.cloudflare.com/ajax/libs/html5shiv/3.7.3/html5shiv-printshiv.min.js"></script>
  <![endif]-->
</head>

<body>

<header id="title-block-header">
<h1 class="title">Creating Georectified Maps of Refugee and Asylum Flows</h1>

<p class="date" id="date"><em>2019-09-10</em></p>

<div id="author-block">
<span id="author-name">Joshua Brinks</span>,&nbsp;<span id="author-affiliation"><em>ISciences, LLC</em>&nbsp;<sup><a id="author-email" href="mailto:jbrinks@iscience.com"><i class="far fa-envelope" style="font-size:15px; color: blue"></i></a></sup></br>
</div>

<div id="vignette-highlights-block">
<h3> Highlights: </h3>
<ul>
<li>Network analysis is often used for causal inference, but here we employ it for visualizing refugee flows.</li>
<li>There’s no unified R platform for creating geo-rectified network maps, but we’ll construct a workflow.</li>
</ul>
</div>



</header>

<h3> Contents: </h3>
<nav id="TOC" role="doc-toc">
<ul>
<li><a href="#introduction"><span class="toc-section-number">1</span> Introduction</a></li>
<li><a href="#packages-and-data"><span class="toc-section-number">2</span> Packages and Data</a></li>
<li><a href="#preparing-the-dyadic-refugee-flows"><span class="toc-section-number">3</span> Preparing the Dyadic Refugee Flows</a></li>
<li><a href="#setting-up-the-network-objects"><span class="toc-section-number">4</span> Setting up the Network Objects</a><ul>
<li><a href="#merging-spatial-information-to-the-nodes"><span class="toc-section-number">4.1</span> Merging Spatial Information to the Nodes</a></li>
<li><a href="#creating-the-network-object"><span class="toc-section-number">4.2</span> Creating the Network Object</a></li>
<li><a href="#acquiring-the-basemap"><span class="toc-section-number">4.3</span> Acquiring the Basemap</a></li>
<li><a href="#putting-it-all-together"><span class="toc-section-number">4.4</span> Putting It All Together</a></li>
</ul></li>
</ul>
</nav>

<div id="introduction" class="section level1">
<h1><span class="header-section-number">1</span> Introduction</h1>
<p>Network analysis is a powerful tool for visualizing and analyzing dyadic data. They can illuminate interesting trends and underlying causal mechanisms. Although much of network theory was born out of sociological research, it has expanded into computational and evolutionary biology, linguistics, economics, and international relations. Network analysis and visualizations are well suited for dyadic international data. This may include trade, conflict, migration flows, or a variety of dyadic data. For this vignette we will create network plots for dyadic refugee flows.</p>
</div>
<div id="packages-and-data" class="section level1">
<h1><span class="header-section-number">2</span> Packages and Data</h1>
<p>When it comes to network analysis in R, there is no singular package for all your network needs. In fact, there are numerous packages and I struggled to define an efficient workflow in preparation of this tutorial. Some of the most discussed in the blogospher and forumsphere are <em>igraph</em>, <em>network</em>, <em>ggraph</em>, <em>ggnet</em>, <em>tidygraph</em>. At first glance, <em>ggnet</em>, <em>tidygraph</em>, or <em>ggraph</em> would presumably garner the benefits of <em>tidyverse</em> management and plotting, however, while partially true, none of them are fully mature packages with complete analytical and visual integration. Moreover, they are mostly wrappers for <em>igraph</em>, which appears to be the leading choice for network analysis with a slew of vignettes and blog posts scattered across the web. After some trial and error I discovered you need to leverage several packages for aesthetically pleasing geo-rectified visualizations using tile mapping services. We’ll start by loading a variety of packages and a palette.</p>
<div class="sourceCode" id="cb1"><pre class="sourceCode r"><code class="sourceCode r"><a class="sourceLine" id="cb1-1" data-line-number="1"><span class="kw">library</span>(data.table)</a>
<a class="sourceLine" id="cb1-2" data-line-number="2"><span class="kw">library</span>(untools)</a>
<a class="sourceLine" id="cb1-3" data-line-number="3"><span class="kw">library</span>(ggmap)</a>
<a class="sourceLine" id="cb1-4" data-line-number="4"><span class="kw">library</span>(ggraph)</a>
<a class="sourceLine" id="cb1-5" data-line-number="5"><span class="kw">library</span>(igraph)</a>
<a class="sourceLine" id="cb1-6" data-line-number="6"><span class="kw">library</span>(tidygraph)</a>
<a class="sourceLine" id="cb1-7" data-line-number="7"><span class="kw">library</span>(untools)</a>
<a class="sourceLine" id="cb1-8" data-line-number="8"><span class="kw">library</span>(raster)</a>
<a class="sourceLine" id="cb1-9" data-line-number="9"><span class="kw">library</span>(maps)</a>
<a class="sourceLine" id="cb1-10" data-line-number="10"><span class="kw">library</span>(countrycode)</a>
<a class="sourceLine" id="cb1-11" data-line-number="11">palette&lt;-<span class="kw">c</span>(<span class="st">&quot;#266197&quot;</span>, <span class="st">&quot;#82dc59&quot;</span>, <span class="st">&quot;#a90aa1&quot;</span>, <span class="st">&quot;#6dc5dd&quot;</span>, <span class="st">&quot;#794a98&quot;</span>, <span class="st">&quot;#57ecc0&quot;</span>, <span class="st">&quot;#808080&quot;</span>)</a></code></pre></div>
</div>
<div id="preparing-the-dyadic-refugee-flows" class="section level1">
<h1><span class="header-section-number">3</span> Preparing the Dyadic Refugee Flows</h1>
<p>Let’s begin by acquiring the dyadic refugee flow data. You can use the <code>geunref()</code> function to acquire the dataset, or download the United Nations Population Statistics Time Series data from <a href="http://popstats.unhcr.org/en/time_series/https://goo.gl/VNuKbU">here</a>. For more information processing and visualizing this dataset using the <em>untools</em> package please refer to <em>Exploring United Nations Refugee &amp; Asylum Data With the untools Package</em>. Once you’ve acquired the data and it’s in your home directory, read it into R and prepare it with the <code>prepunref()</code> function. The time series dates back to 1951 and contains multiple subgroups (refugees, asylum seekers, stateless persons, internally displaced persons, etc.). For a more manageable dataset and visualizations, lets only analyze cumulative refugee flows from 2010–2017. The <code>prepunref()</code> function will not sum across years, just groups,</p>
<div class="sourceCode" id="cb2"><pre class="sourceCode r"><code class="sourceCode r"><a class="sourceLine" id="cb2-1" data-line-number="1">unhcr&lt;-<span class="kw">getunref</span>()</a>
<a class="sourceLine" id="cb2-2" data-line-number="2">unhcr&lt;-<span class="kw">prepunref</span>(unhcr, <span class="dt">groups =</span> <span class="st">&#39;ref&#39;</span>, <span class="dt">range =</span> <span class="kw">c</span>(<span class="dv">2010</span>,<span class="dv">2017</span>), <span class="dt">sum_years =</span> <span class="ot">TRUE</span>)</a>
<a class="sourceLine" id="cb2-3" data-line-number="3">unhcr&lt;-unhcr[,.(<span class="dt">value=</span><span class="kw">sum</span>(value)), by=.(origin_iso,destination_iso, origin, destination)]</a></code></pre></div>
<p>Verify we got what we wanted:</p>
<div class="sourceCode" id="cb3"><pre class="sourceCode r"><code class="sourceCode r"><a class="sourceLine" id="cb3-1" data-line-number="1"><span class="kw">kable</span>(unhcr[<span class="dv">1</span><span class="op">:</span><span class="dv">10</span>])</a></code></pre></div>
<table>
<thead>
<tr>
<th style="text-align:left;">
origin_iso
</th>
<th style="text-align:left;">
destination_iso
</th>
<th style="text-align:left;">
origin
</th>
<th style="text-align:left;">
destination
</th>
<th style="text-align:right;">
value
</th>
</tr>
</thead>
<tbody>
<tr>
<td style="text-align:left;">
IRN
</td>
<td style="text-align:left;">
AFG
</td>
<td style="text-align:left;">
Iran (Islamic Rep. of)
</td>
<td style="text-align:left;">
Afghanistan
</td>
<td style="text-align:right;">
270
</td>
</tr>
<tr>
<td style="text-align:left;">
IRQ
</td>
<td style="text-align:left;">
AFG
</td>
<td style="text-align:left;">
Iraq
</td>
<td style="text-align:left;">
Afghanistan
</td>
<td style="text-align:right;">
15
</td>
</tr>
<tr>
<td style="text-align:left;">
PAK
</td>
<td style="text-align:left;">
AFG
</td>
<td style="text-align:left;">
Pakistan
</td>
<td style="text-align:left;">
Afghanistan
</td>
<td style="text-align:right;">
735880
</td>
</tr>
<tr>
<td style="text-align:left;">
PSE
</td>
<td style="text-align:left;">
AFG
</td>
<td style="text-align:left;">
Palestinian
</td>
<td style="text-align:left;">
Afghanistan
</td>
<td style="text-align:right;">
2
</td>
</tr>
<tr>
<td style="text-align:left;">
SYR
</td>
<td style="text-align:left;">
AFG
</td>
<td style="text-align:left;">
Syrian Arab Rep.
</td>
<td style="text-align:left;">
Afghanistan
</td>
<td style="text-align:right;">
1
</td>
</tr>
<tr>
<td style="text-align:left;">
DZA
</td>
<td style="text-align:left;">
ALB
</td>
<td style="text-align:left;">
Algeria
</td>
<td style="text-align:left;">
Albania
</td>
<td style="text-align:right;">
2
</td>
</tr>
<tr>
<td style="text-align:left;">
CHN
</td>
<td style="text-align:left;">
ALB
</td>
<td style="text-align:left;">
China
</td>
<td style="text-align:left;">
Albania
</td>
<td style="text-align:right;">
83
</td>
</tr>
<tr>
<td style="text-align:left;">
CZE
</td>
<td style="text-align:left;">
ALB
</td>
<td style="text-align:left;">
Czech Rep.
</td>
<td style="text-align:left;">
Albania
</td>
<td style="text-align:right;">
4
</td>
</tr>
<tr>
<td style="text-align:left;">
COD
</td>
<td style="text-align:left;">
ALB
</td>
<td style="text-align:left;">
Dem. Rep. of the Congo
</td>
<td style="text-align:left;">
Albania
</td>
<td style="text-align:right;">
12
</td>
</tr>
<tr>
<td style="text-align:left;">
EGY
</td>
<td style="text-align:left;">
ALB
</td>
<td style="text-align:left;">
Egypt
</td>
<td style="text-align:left;">
Albania
</td>
<td style="text-align:right;">
20
</td>
</tr>
</tbody>
</table>
<p>Although we have cumulative dyadic flows for the 8 years we specified, I suspect this will still be too many observations for an interpretable analysis and any visualizations will be littered flows in every direction. Let’s grab some additional information.</p>
<div class="sourceCode" id="cb4"><pre class="sourceCode r"><code class="sourceCode r"><a class="sourceLine" id="cb4-1" data-line-number="1"><span class="kw">nrow</span>(unhcr)</a></code></pre></div>
<pre><code>## [1] 6519</code></pre>
<div class="sourceCode" id="cb6"><pre class="sourceCode r"><code class="sourceCode r"><a class="sourceLine" id="cb6-1" data-line-number="1"><span class="kw">length</span>(<span class="kw">unique</span>(unhcr<span class="op">$</span>origin))</a></code></pre></div>
<pre><code>## [1] 207</code></pre>
<div class="sourceCode" id="cb8"><pre class="sourceCode r"><code class="sourceCode r"><a class="sourceLine" id="cb8-1" data-line-number="1"><span class="kw">length</span>(<span class="kw">unique</span>(unhcr<span class="op">$</span>destination))</a></code></pre></div>
<pre><code>## [1] 185</code></pre>
<p>Nearly 9,000 flows between roughly 200 origin and destination countries will be unruly. To make the data more manageable let’s identify the top 15 origin countries, top 15 destination countries, and extract only dyadic flows involving each other. First examine the top sources of refugees in our time period.</p>
<div class="sourceCode" id="cb10"><pre class="sourceCode r"><code class="sourceCode r"><a class="sourceLine" id="cb10-1" data-line-number="1">top.origin&lt;-unhcr[,.(<span class="dt">value=</span><span class="kw">sum</span>(value)), by=origin][<span class="kw">order</span>(<span class="op">-</span>value)][<span class="dv">1</span><span class="op">:</span><span class="dv">15</span>]</a></code></pre></div>
<table>
<thead>
<tr>
<th style="text-align:left;">
origin
</th>
<th style="text-align:right;">
value
</th>
</tr>
</thead>
<tbody>
<tr>
<td style="text-align:left;">
Syrian Arab Rep.
</td>
<td style="text-align:right;">
23829471
</td>
</tr>
<tr>
<td style="text-align:left;">
Afghanistan
</td>
<td style="text-align:right;">
21250064
</td>
</tr>
<tr>
<td style="text-align:left;">
Somalia
</td>
<td style="text-align:right;">
8333968
</td>
</tr>
<tr>
<td style="text-align:left;">
Iraq
</td>
<td style="text-align:right;">
5572155
</td>
</tr>
<tr>
<td style="text-align:left;">
South Sudan
</td>
<td style="text-align:right;">
5473008
</td>
</tr>
<tr>
<td style="text-align:left;">
Sudan
</td>
<td style="text-align:right;">
4743411
</td>
</tr>
<tr>
<td style="text-align:left;">
Myanmar
</td>
<td style="text-align:right;">
4303105
</td>
</tr>
<tr>
<td style="text-align:left;">
Dem. Rep. of the Congo
</td>
<td style="text-align:right;">
4193550
</td>
</tr>
<tr>
<td style="text-align:left;">
Colombia
</td>
<td style="text-align:right;">
2785458
</td>
</tr>
<tr>
<td style="text-align:left;">
Eritrea
</td>
<td style="text-align:right;">
2784177
</td>
</tr>
<tr>
<td style="text-align:left;">
Central African Rep.
</td>
<td style="text-align:right;">
2664742
</td>
</tr>
<tr>
<td style="text-align:left;">
Viet Nam
</td>
<td style="text-align:right;">
2617553
</td>
</tr>
<tr>
<td style="text-align:left;">
China
</td>
<td style="text-align:right;">
1602738
</td>
</tr>
<tr>
<td style="text-align:left;">
Burundi
</td>
<td style="text-align:right;">
1543996
</td>
</tr>
<tr>
<td style="text-align:left;">
Rwanda
</td>
<td style="text-align:right;">
1314500
</td>
</tr>
</tbody>
</table>
<p>Not a lot of surprises with the sources of refugees since 2010. Now lets look at the destination countries that received the most refugees.</p>
<div class="sourceCode" id="cb11"><pre class="sourceCode r"><code class="sourceCode r"><a class="sourceLine" id="cb11-1" data-line-number="1">top.destination&lt;-unhcr[,.(<span class="dt">value=</span><span class="kw">sum</span>(value)), by=destination][<span class="kw">order</span>(<span class="op">-</span>value)][<span class="dv">1</span><span class="op">:</span><span class="dv">15</span>]</a>
<a class="sourceLine" id="cb11-2" data-line-number="2"><span class="kw">kable</span>(top.destination)</a></code></pre></div>
<table>
<thead>
<tr>
<th style="text-align:left;">
destination
</th>
<th style="text-align:right;">
value
</th>
</tr>
</thead>
<tbody>
<tr>
<td style="text-align:left;">
Pakistan
</td>
<td style="text-align:right;">
12670663
</td>
</tr>
<tr>
<td style="text-align:left;">
Turkey
</td>
<td style="text-align:right;">
11379975
</td>
</tr>
<tr>
<td style="text-align:left;">
Iran (Islamic Rep. of)
</td>
<td style="text-align:right;">
7605764
</td>
</tr>
<tr>
<td style="text-align:left;">
Lebanon
</td>
<td style="text-align:right;">
5244278
</td>
</tr>
<tr>
<td style="text-align:left;">
Jordan
</td>
<td style="text-align:right;">
4541012
</td>
</tr>
<tr>
<td style="text-align:left;">
Ethiopia
</td>
<td style="text-align:right;">
4330110
</td>
</tr>
<tr>
<td style="text-align:left;">
Germany
</td>
<td style="text-align:right;">
4116145
</td>
</tr>
<tr>
<td style="text-align:left;">
Kenya
</td>
<td style="text-align:right;">
4057514
</td>
</tr>
<tr>
<td style="text-align:left;">
Uganda
</td>
<td style="text-align:right;">
3847711
</td>
</tr>
<tr>
<td style="text-align:left;">
Chad
</td>
<td style="text-align:right;">
3147759
</td>
</tr>
<tr>
<td style="text-align:left;">
Syrian Arab Rep.
</td>
<td style="text-align:right;">
2596200
</td>
</tr>
<tr>
<td style="text-align:left;">
Bangladesh
</td>
<td style="text-align:right;">
2593610
</td>
</tr>
<tr>
<td style="text-align:left;">
Sudan
</td>
<td style="text-align:right;">
2545297
</td>
</tr>
<tr>
<td style="text-align:left;">
China
</td>
<td style="text-align:right;">
2445150
</td>
</tr>
<tr>
<td style="text-align:left;">
United States of America
</td>
<td style="text-align:right;">
2155493
</td>
</tr>
</tbody>
</table>
<p>We see that Pakistan, Turkey, Iran, Lebanon, and Jordan have received hundreds of thousands of refugees since 2010 with Pakistan and Turkey receiving more than 1 million. Now we can create a character vector of the unique countries in these two subsets and use it to filter our original data.</p>
<div class="sourceCode" id="cb12"><pre class="sourceCode r"><code class="sourceCode r"><a class="sourceLine" id="cb12-1" data-line-number="1">countries&lt;-<span class="kw">unique</span>(<span class="kw">c</span>(<span class="kw">as.character</span>(top.origin<span class="op">$</span>origin), <span class="kw">as.character</span>(top.destination<span class="op">$</span>destination)))</a>
<a class="sourceLine" id="cb12-2" data-line-number="2">countries</a></code></pre></div>
<pre><code>##  [1] &quot;Syrian Arab Rep.&quot;         &quot;Afghanistan&quot;             
##  [3] &quot;Somalia&quot;                  &quot;Iraq&quot;                    
##  [5] &quot;South Sudan&quot;              &quot;Sudan&quot;                   
##  [7] &quot;Myanmar&quot;                  &quot;Dem. Rep. of the Congo&quot;  
##  [9] &quot;Colombia&quot;                 &quot;Eritrea&quot;                 
## [11] &quot;Central African Rep.&quot;     &quot;Viet Nam&quot;                
## [13] &quot;China&quot;                    &quot;Burundi&quot;                 
## [15] &quot;Rwanda&quot;                   &quot;Pakistan&quot;                
## [17] &quot;Turkey&quot;                   &quot;Iran (Islamic Rep. of)&quot;  
## [19] &quot;Lebanon&quot;                  &quot;Jordan&quot;                  
## [21] &quot;Ethiopia&quot;                 &quot;Germany&quot;                 
## [23] &quot;Kenya&quot;                    &quot;Uganda&quot;                  
## [25] &quot;Chad&quot;                     &quot;Bangladesh&quot;              
## [27] &quot;United States of America&quot;</code></pre>
<div class="sourceCode" id="cb14"><pre class="sourceCode r"><code class="sourceCode r"><a class="sourceLine" id="cb14-1" data-line-number="1">unhcr&lt;-unhcr[origin <span class="op">%in%</span><span class="st"> </span>countries <span class="op">&amp;</span><span class="st"> </span>destination <span class="op">%in%</span><span class="st"> </span>countries]</a>
<a class="sourceLine" id="cb14-2" data-line-number="2"><span class="kw">nrow</span>(unhcr)</a></code></pre></div>
<pre><code>## [1] 317</code></pre>
<div class="sourceCode" id="cb16"><pre class="sourceCode r"><code class="sourceCode r"><a class="sourceLine" id="cb16-1" data-line-number="1"><span class="kw">length</span>(<span class="kw">unique</span>(unhcr<span class="op">$</span>origin))</a></code></pre></div>
<pre><code>## [1] 27</code></pre>
<div class="sourceCode" id="cb18"><pre class="sourceCode r"><code class="sourceCode r"><a class="sourceLine" id="cb18-1" data-line-number="1"><span class="kw">length</span>(<span class="kw">unique</span>(unhcr<span class="op">$</span>destination))</a></code></pre></div>
<pre><code>## [1] 25</code></pre>
<p>This will be a lot easier to work with, but 373 flows may still be a bit much for a visualization. Let’s examine the distribution of flows to potentially eliminate smaller observations</p>
<div class="sourceCode" id="cb20"><pre class="sourceCode r"><code class="sourceCode r"><a class="sourceLine" id="cb20-1" data-line-number="1"><span class="kw">ggplot</span>(unhcr, <span class="kw">aes</span>(value))<span class="op">+</span></a>
<a class="sourceLine" id="cb20-2" data-line-number="2"><span class="st">  </span><span class="kw">geom_histogram</span>(<span class="dt">fill=</span>palette[<span class="dv">1</span>])<span class="op">+</span></a>
<a class="sourceLine" id="cb20-3" data-line-number="3"><span class="st">  </span><span class="kw">labs</span>(<span class="dt">y=</span><span class="st">&#39;Counts&#39;</span>,</a>
<a class="sourceLine" id="cb20-4" data-line-number="4">       <span class="dt">x=</span><span class="st">&#39;Refugee Flows&#39;</span>)<span class="op">+</span></a>
<a class="sourceLine" id="cb20-5" data-line-number="5"><span class="st">  </span><span class="kw">theme_minimal</span>()</a></code></pre></div>
<pre><code>## `stat_bin()` using `bins = 30`. Pick better value with `binwidth`.</code></pre>
<p><img src="unref-networks_files/figure-html/unnamed-chunk-11-1.svg" width="672" /></p>
<div class="sourceCode" id="cb22"><pre class="sourceCode r"><code class="sourceCode r"><a class="sourceLine" id="cb22-1" data-line-number="1"><span class="kw">quantile</span>(unhcr<span class="op">$</span>value, <span class="dt">probs=</span><span class="kw">seq</span>(<span class="dv">0</span>,<span class="dv">1</span>,.<span class="dv">1</span>))</a></code></pre></div>
<pre><code>##         0%        10%        20%        30%        40%        50% 
##        0.0        4.0        9.2       26.0       74.4      183.0 
##        60%        70%        80%        90%       100% 
##     1605.6     8477.8    34243.2   307599.2 12665677.0</code></pre>
<p>Yikes. The majority of the data is clustered near 0 along with some massive outliers. The quantile distribution exhibits massive spikes at nearly every decile after 50%. A reasonable cutoff for visualization might by 3000. Let’s view a subset of at least 3000 refugees.</p>
<div class="sourceCode" id="cb24"><pre class="sourceCode r"><code class="sourceCode r"><a class="sourceLine" id="cb24-1" data-line-number="1"><span class="kw">ggplot</span>(unhcr[value<span class="op">&gt;=</span><span class="dv">3000</span>], <span class="kw">aes</span>(value))<span class="op">+</span></a>
<a class="sourceLine" id="cb24-2" data-line-number="2"><span class="st">  </span><span class="kw">geom_histogram</span>(<span class="dt">fill=</span>palette[<span class="dv">1</span>])<span class="op">+</span></a>
<a class="sourceLine" id="cb24-3" data-line-number="3"><span class="st">  </span><span class="kw">labs</span>(<span class="dt">y=</span><span class="st">&#39;Counts&#39;</span>,</a>
<a class="sourceLine" id="cb24-4" data-line-number="4">       <span class="dt">x=</span><span class="st">&#39;Refugee Flows&#39;</span>)<span class="op">+</span></a>
<a class="sourceLine" id="cb24-5" data-line-number="5"><span class="st">  </span><span class="kw">theme_minimal</span>()</a></code></pre></div>
<pre><code>## `stat_bin()` using `bins = 30`. Pick better value with `binwidth`.</code></pre>
<p><img src="unref-networks_files/figure-html/unnamed-chunk-12-1.svg" width="672" /></p>
<div class="sourceCode" id="cb26"><pre class="sourceCode r"><code class="sourceCode r"><a class="sourceLine" id="cb26-1" data-line-number="1"><span class="kw">nrow</span>(unhcr[value<span class="op">&gt;</span><span class="dv">3000</span>])</a></code></pre></div>
<pre><code>## [1] 117</code></pre>
<p>The distribution is still rather skewed, but the total number of observations is down to 117 and we’re focused on visualization, not modeling, so let’s carry on with a proper subset of the data.</p>
<div class="sourceCode" id="cb28"><pre class="sourceCode r"><code class="sourceCode r"><a class="sourceLine" id="cb28-1" data-line-number="1">unhcr<span class="fl">.3</span>k&lt;-unhcr[value<span class="op">&gt;=</span><span class="dv">3000</span>]</a></code></pre></div>
</div>
<div id="setting-up-the-network-objects" class="section level1">
<h1><span class="header-section-number">4</span> Setting up the Network Objects</h1>
<p>Network analysis is defined by edges and nodes. In our scenario, the nodes are the countries while the edges are the flows of refugees between them. Furthermore, the inputs to network functions are separated into distinct objects defining the nodes and edges. The object defining the edges is a 3 column data frame with origin, destination, and edge (refugee flow). The object defining the nodes is, at minimum, a single column data frame with a list of the nodes. The node object may also include additional columns describing the nodes. For example, they may include total population, national economic indicators, or climate statistics. Because we want to create geo-rectified plots, our node object must contain spatial information defining the country locations. This can be achieved in multiple ways, but we will use the latitude and longitude of the capital cities. We’ll establish the node and edge objects before adding the spatial information to the nodes; this simplifies the process and makes the objects easier to work with. From here on we’ll be working with just the ISO country codes; full country names are not good for visualizations.</p>
<div class="sourceCode" id="cb29"><pre class="sourceCode r"><code class="sourceCode r"><a class="sourceLine" id="cb29-1" data-line-number="1">nodes&lt;-<span class="kw">data.table</span>(<span class="dt">nodes=</span><span class="kw">unique</span>(<span class="kw">c</span>(<span class="kw">as.character</span>(unhcr<span class="fl">.3</span>k<span class="op">$</span>origin_iso),<span class="kw">as.character</span>(unhcr<span class="fl">.3</span>k<span class="op">$</span>destination_iso))))</a>
<a class="sourceLine" id="cb29-2" data-line-number="2">edges&lt;-unhcr<span class="fl">.3</span>k[,.(origin_iso,destination_iso,value)]</a></code></pre></div>
<div id="merging-spatial-information-to-the-nodes" class="section level2">
<h2><span class="header-section-number">4.1</span> Merging Spatial Information to the Nodes</h2>
<p>Several R packages come pre-loaded with useful data that would otherwise take several processing steps to acquire. We will be using spatial attributes of world cities from the <em>maps</em> package to merge capital city latitude and longitude onto our refugee source and origin nodes. If you were interested in subsetting countries by world regions as opposed to the greatest sources and destination for refugee flows you might want to use <code>raster::ccodes()</code> to acquire United Nations regional affiliations. Let’s pull in the cities data to an object, subset only the capital cities, use the <em>countrycode</em> package to create a new field with ISO codes, and finally merge only the spatial information with our node object using the newly established ISO3 country code.</p>
<div class="sourceCode" id="cb30"><pre class="sourceCode r"><code class="sourceCode r"><a class="sourceLine" id="cb30-1" data-line-number="1">world.cities&lt;-<span class="kw">setDT</span>(maps<span class="op">::</span>world.cities)</a>
<a class="sourceLine" id="cb30-2" data-line-number="2">capitals&lt;-world.cities[capital<span class="op">==</span><span class="dv">1</span>]</a>
<a class="sourceLine" id="cb30-3" data-line-number="3">capitals[,iso3<span class="op">:</span><span class="er">=</span><span class="kw">countrycode</span>(country.etc, <span class="dt">origin =</span> <span class="st">&#39;country.name&#39;</span>, <span class="dt">destination =</span> <span class="st">&#39;iso3c&#39;</span>)]</a></code></pre></div>
<pre><code>## Warning in countrycode(country.etc, origin = &quot;country.name&quot;, destination = &quot;iso3c&quot;): Some values were not matched unambiguously: Micronesia, Netherlands Antilles, Serbia and Montenegro</code></pre>
<div class="sourceCode" id="cb32"><pre class="sourceCode r"><code class="sourceCode r"><a class="sourceLine" id="cb32-1" data-line-number="1">nodes&lt;-<span class="kw">merge</span>(nodes, capitals[,.(iso3,lat,long)], <span class="dt">by.x=</span><span class="st">&#39;nodes&#39;</span>, <span class="dt">by.y=</span><span class="st">&#39;iso3&#39;</span>, <span class="dt">all.x=</span><span class="ot">TRUE</span>)</a></code></pre></div>
<p>Not surprisingly, <em>countrycode</em> kicked out an error; it didn’t recognize a few countries in the capitals dataset. Thankfully they are not part of our top countries. While that is good news, a brief look at the post merged data reveals <code>NA</code> values for South Sudan. This is not surprising as South Sudan was established after the 2011 Sudanese Civil War.</p>
<div class="sourceCode" id="cb33"><pre class="sourceCode r"><code class="sourceCode r"><a class="sourceLine" id="cb33-1" data-line-number="1">nodes[nodes<span class="op">==</span><span class="st">&#39;SSD&#39;</span>]</a></code></pre></div>
<div class="kable-table">

<table>
<thead>
<tr>
<th style="text-align:left;">
nodes
</th>
<th style="text-align:right;">
lat
</th>
<th style="text-align:right;">
long
</th>
</tr>
</thead>
<tbody>
<tr>
<td style="text-align:left;">
SSD
</td>
<td style="text-align:right;">
NA
</td>
<td style="text-align:right;">
NA
</td>
</tr>
</tbody>
</table>
</div>
<p>The capital city of South Sudan is Juda, which is listed under Sudan, not South Sudan, in the <code>world.cities</code> dataset. We can fill in the values ad-hoc.</p>
<div class="sourceCode" id="cb34"><pre class="sourceCode r"><code class="sourceCode r"><a class="sourceLine" id="cb34-1" data-line-number="1">nodes[nodes<span class="op">==</span><span class="st">&#39;SSD&#39;</span>, lat<span class="op">:</span><span class="er">=</span>world.cities[name<span class="op">==</span><span class="st">&#39;Juba&#39;</span>,lat]][nodes<span class="op">==</span><span class="st">&#39;SSD&#39;</span>, long<span class="op">:</span><span class="er">=</span>world.cities[name<span class="op">==</span><span class="st">&#39;Juba&#39;</span>,long]]</a></code></pre></div>
</div>
<div id="creating-the-network-object" class="section level2">
<h2><span class="header-section-number">4.2</span> Creating the Network Object</h2>
<p>In my experience, <code>tidygraph</code>, <code>ggraph</code>, and <code>ggmap</code> are sensitive to the naming structures present in the node and edge objects. I’m not certain of the specific mechanisms, but through trial and error I discovered the correct conventions for the desired output. The objects should be named <code>edges</code> and <code>nodes</code>, the lat/long coordinates should be renamed y/x, and the flows or edges should be named weights. Let’s rename the relevant variables.</p>
<div class="sourceCode" id="cb35"><pre class="sourceCode r"><code class="sourceCode r"><a class="sourceLine" id="cb35-1" data-line-number="1"><span class="kw">names</span>(edges)[<span class="dv">3</span>]&lt;-<span class="st">&#39;weight&#39;</span></a>
<a class="sourceLine" id="cb35-2" data-line-number="2"><span class="kw">names</span>(nodes)[<span class="dv">2</span><span class="op">:</span><span class="dv">3</span>]&lt;-<span class="kw">c</span>(<span class="st">&#39;y&#39;</span>,<span class="st">&#39;x&#39;</span>)</a></code></pre></div>
<p>Now we can use <code>tbl_graph()</code> to set up our network and <code>ggraph()</code> for an initial look at the network.</p>
<div class="sourceCode" id="cb36"><pre class="sourceCode r"><code class="sourceCode r"><a class="sourceLine" id="cb36-1" data-line-number="1">flows&lt;-<span class="kw">tbl_graph</span>(<span class="dt">nodes=</span>nodes, <span class="dt">edges =</span> edges, <span class="dt">directed =</span> <span class="ot">TRUE</span>)</a>
<a class="sourceLine" id="cb36-2" data-line-number="2"><span class="kw">plot</span>(flows)</a></code></pre></div>
<p><img src="unref-networks_files/figure-html/unnamed-chunk-19-1.svg" width="672" /></p>
<p>The first view of our network; not very illuminating. There are additional options to spruce this up, but for now we’ll move on to place it in geo-rectified space. Next we’ll convert our <em>tidygraph</em> object created by <code>tbl_graph()</code> into an object capable of being plotted on a map using <code>ggraph()</code>.</p>
<div class="sourceCode" id="cb37"><pre class="sourceCode r"><code class="sourceCode r"><a class="sourceLine" id="cb37-1" data-line-number="1">gg&lt;-<span class="kw">ggraph</span>(flows, <span class="dt">layout=</span><span class="st">&#39;nicely&#39;</span>)</a></code></pre></div>
</div>
<div id="acquiring-the-basemap" class="section level2">
<h2><span class="header-section-number">4.3</span> Acquiring the Basemap</h2>
<p>Next we need to establish the bounding box for the basemap and pad it a bit so the capital city is not directly on the edge of the map. Then we’ll use those coordinates to acquire the basemap from the tile server</p>
<div class="sourceCode" id="cb38"><pre class="sourceCode r"><code class="sourceCode r"><a class="sourceLine" id="cb38-1" data-line-number="1"><span class="co"># Get the basemap</span></a>
<a class="sourceLine" id="cb38-2" data-line-number="2">x.range &lt;-<span class="st"> </span>(<span class="kw">max</span>(nodes<span class="op">$</span>x) <span class="op">-</span><span class="st"> </span><span class="kw">min</span>(nodes<span class="op">$</span>x))<span class="op">/</span><span class="dv">20</span></a>
<a class="sourceLine" id="cb38-3" data-line-number="3">y.range &lt;-<span class="st"> </span>(<span class="kw">max</span>(nodes<span class="op">$</span>y) <span class="op">-</span><span class="st"> </span><span class="kw">min</span>(nodes<span class="op">$</span>y))<span class="op">/</span><span class="dv">20</span></a>
<a class="sourceLine" id="cb38-4" data-line-number="4"></a>
<a class="sourceLine" id="cb38-5" data-line-number="5">coords &lt;-<span class="st"> </span><span class="kw">c</span>(<span class="dt">left =</span> <span class="kw">min</span>(nodes<span class="op">$</span>x)<span class="op">-</span>x.range, </a>
<a class="sourceLine" id="cb38-6" data-line-number="6">            <span class="dt">bottom =</span> <span class="kw">min</span>(nodes<span class="op">$</span>y)<span class="op">-</span>y.range, </a>
<a class="sourceLine" id="cb38-7" data-line-number="7">            <span class="dt">right =</span> <span class="kw">max</span>(nodes<span class="op">$</span>x)<span class="op">+</span>x.range, </a>
<a class="sourceLine" id="cb38-8" data-line-number="8">            <span class="dt">top =</span> <span class="kw">max</span>(nodes<span class="op">$</span>y)<span class="op">+</span>y.range)</a></code></pre></div>
<p>Now acquire the basemap from the tile server using the bounding box.</p>
<div class="sourceCode" id="cb39"><pre class="sourceCode r"><code class="sourceCode r"><a class="sourceLine" id="cb39-1" data-line-number="1">basemap &lt;-<span class="st"> </span><span class="kw">get_stamenmap</span>(coords, <span class="dt">zoom =</span> <span class="dv">4</span>, <span class="dt">maptype =</span> <span class="st">&quot;toner-lite&quot;</span>)</a>
<a class="sourceLine" id="cb39-2" data-line-number="2"><span class="kw">ggmap</span>(basemap)</a></code></pre></div>
<p><img src="unref-networks_files/figure-html/unnamed-chunk-22-1.svg" width="672" /></p>
</div>
<div id="putting-it-all-together" class="section level2">
<h2><span class="header-section-number">4.4</span> Putting It All Together</h2>
<p>Now we’ll overlay our network object onto the basemap along with points for the capital cities using <code>ggmap()</code>.</p>
<div class="sourceCode" id="cb40"><pre class="sourceCode r"><code class="sourceCode r"><a class="sourceLine" id="cb40-1" data-line-number="1">network.map&lt;-<span class="kw">ggmap</span>(basemap, <span class="dt">base_layer =</span> gg) <span class="op">+</span></a>
<a class="sourceLine" id="cb40-2" data-line-number="2"><span class="st">  </span><span class="kw">geom_node_point</span>() <span class="op">+</span></a>
<a class="sourceLine" id="cb40-3" data-line-number="3"><span class="st">  </span><span class="kw">geom_edge_fan</span>()</a>
<a class="sourceLine" id="cb40-4" data-line-number="4"></a>
<a class="sourceLine" id="cb40-5" data-line-number="5">network.map</a></code></pre></div>
<p><img src="unref-networks_files/figure-html/unnamed-chunk-23-1.svg" width="672" /></p>
<p>It worked! It looks terrible! We’ll modernize this with a slew of additional options.</p>
<div class="sourceCode" id="cb41"><pre class="sourceCode r"><code class="sourceCode r"><a class="sourceLine" id="cb41-1" data-line-number="1">network.map&lt;-<span class="kw">ggmap</span>(basemap, <span class="dt">base_layer =</span> gg) <span class="op">+</span></a>
<a class="sourceLine" id="cb41-2" data-line-number="2"><span class="st">  </span><span class="kw">geom_node_point</span>(<span class="dt">size =</span> <span class="fl">1.5</span>, <span class="dt">show.legend =</span> F, <span class="dt">alpha=</span><span class="fl">0.75</span>, <span class="dt">colour=</span>palette[<span class="dv">6</span>]) <span class="op">+</span></a>
<a class="sourceLine" id="cb41-3" data-line-number="3"><span class="st">  </span><span class="kw">geom_edge_arc</span>(<span class="dt">colour=</span>palette[<span class="dv">1</span>], </a>
<a class="sourceLine" id="cb41-4" data-line-number="4">                <span class="dt">curvature =</span> <span class="fl">0.15</span>,</a>
<a class="sourceLine" id="cb41-5" data-line-number="5">                <span class="dt">lineend =</span> <span class="st">&#39;butt&#39;</span>,</a>
<a class="sourceLine" id="cb41-6" data-line-number="6">                <span class="kw">aes</span>(<span class="dt">width =</span> <span class="kw">log</span>(weight), <span class="dt">alpha =</span> <span class="kw">log</span>(weight)),</a>
<a class="sourceLine" id="cb41-7" data-line-number="7">                <span class="dt">arrow =</span> <span class="kw">arrow</span>(<span class="dt">length =</span> <span class="kw">unit</span>(<span class="fl">1.5</span>, <span class="st">&#39;mm&#39;</span>), <span class="dt">type=</span><span class="st">&#39;closed&#39;</span>, <span class="dt">angle =</span> <span class="dv">25</span>),</a>
<a class="sourceLine" id="cb41-8" data-line-number="8">                <span class="dt">end_cap =</span> <span class="kw">circle</span>(<span class="dv">3</span>, <span class="st">&#39;mm&#39;</span>),</a>
<a class="sourceLine" id="cb41-9" data-line-number="9">                <span class="dt">start_cap =</span> <span class="kw">circle</span>(<span class="dv">3</span>, <span class="st">&#39;mm&#39;</span>),</a>
<a class="sourceLine" id="cb41-10" data-line-number="10">                <span class="dt">show.legend =</span> F)<span class="op">+</span></a>
<a class="sourceLine" id="cb41-11" data-line-number="11"><span class="st">  </span><span class="kw">scale_edge_width</span>(<span class="dt">range =</span> <span class="kw">c</span>(<span class="fl">0.1</span>, <span class="dv">1</span>)) <span class="op">+</span></a>
<a class="sourceLine" id="cb41-12" data-line-number="12"><span class="st">  </span><span class="kw">scale_edge_alpha</span>(<span class="dt">range =</span> <span class="kw">c</span>(<span class="fl">0.01</span>, <span class="dv">1</span>)) <span class="op">+</span></a>
<a class="sourceLine" id="cb41-13" data-line-number="13"><span class="st">    </span><span class="kw">labs</span>(<span class="co">#title = &#39;Dyadic Refugee Flows During 2010 - 2017&#39;,</span></a>
<a class="sourceLine" id="cb41-14" data-line-number="14">       <span class="co">#subtitle = &#39;For the Top 15 Origin and Destination Countries&#39;,</span></a>
<a class="sourceLine" id="cb41-15" data-line-number="15">       <span class="dt">y=</span><span class="st">&quot;&quot;</span>,</a>
<a class="sourceLine" id="cb41-16" data-line-number="16">       <span class="dt">x=</span><span class="st">&quot;&quot;</span>)<span class="op">+</span></a>
<a class="sourceLine" id="cb41-17" data-line-number="17"><span class="st">  </span><span class="kw">theme_graph</span>()<span class="op">+</span></a>
<a class="sourceLine" id="cb41-18" data-line-number="18"><span class="st">  </span><span class="kw">theme</span>(<span class="dt">axis.ticks=</span><span class="kw">element_blank</span>(),<span class="dt">legend.position =</span> <span class="st">&#39;bottom&#39;</span>,</a>
<a class="sourceLine" id="cb41-19" data-line-number="19">        <span class="dt">panel.border =</span> <span class="kw">element_rect</span>(<span class="dt">colour =</span> palette[<span class="dv">7</span>], <span class="dt">fill=</span><span class="ot">NA</span>, <span class="dt">size=</span><span class="dv">2</span>))</a></code></pre></div>
<pre><code>## Warning: The curvature argument has been deprecated in favour of strength</code></pre>
<div class="sourceCode" id="cb43"><pre class="sourceCode r"><code class="sourceCode r"><a class="sourceLine" id="cb43-1" data-line-number="1">network.map</a></code></pre></div>
<p><img src="unref-networks_files/figure-html/unnamed-chunk-24-1.png" width="960" /></p>
<p>Looks much better. It’s small in the browser but you can save the map to a vectorized format to view it in all of its glory.</p>
<div class="sourceCode" id="cb44"><pre class="sourceCode r"><code class="sourceCode r"><a class="sourceLine" id="cb44-1" data-line-number="1"><span class="kw">ggsave</span>(network.map, <span class="dt">file=</span><span class="st">&#39;ref_network.png&#39;</span>, <span class="dt">dpi=</span><span class="dv">600</span>)</a></code></pre></div>
</div>
</div>

<footer>

<h1> Additional Meta-Data </h1>

<div id="related-packages-block">
<h3> Related Packages: </h3>
<ul>
<li>untools</li>
<li>ggmap</li>
<li>igraph</li>
<li>tidygraph</li>
<li>raster</li>
<li>maps</li>
<li>countrycode</li>
</ul>
</div>

<div id="related-datasets-block">
<h3> Related Data Sets: </h3>
<ul>
<li>The United Nations High Commissioner for Refugees Populations of Concern: Time Series</li>
</ul>
</div>

<div id="data-presentation-forms-block">
<h3> Data Categories:</h3>
<span id="data-presentation-forms">raster, tabular, dyadic flows</span>
</div>

<div id="related-vignettes-block">
<h3> Related Vignettes: </h3>
<ul>
<li>Exploring United Nations Refugee &amp; Asylum Data With the <em>untools</em> Package</li>
</ul>
</div>

</footer>

</body>

</html>
